=begin
#SCORM Cloud Rest API

#REST API used for SCORM Cloud integrations.

OpenAPI spec version: 2.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.12

=end

require 'date'

module RusticiSoftwareCloudV2
  class LaunchLinkRequestSchema
    # Number of seconds from now this link will expire in. Defaults to 120s. Range 10s:300s
    attr_accessor :expiry

    # The URL the application should redirect to when the learner exits a course. If not specified, configured value will be used.
    attr_accessor :redirect_on_exit_url

    # Should this launch be tracked? If false, Engine will avoid tracking to the extent possible for the standard being used.
    attr_accessor :tracking

    # For SCORM, SCO identifier to override launch, overriding the normal sequencing.
    attr_accessor :start_sco

    # This parameter should specify a culture code. If specified, and supported, the navigation and alerts in the player will be displayed in the associated language. If not specified, the locale of the user’s browser will be used.
    attr_accessor :culture

    # A Url pointing to custom css for the player to use.
    attr_accessor :css_url

    attr_accessor :learner_tags

    attr_accessor :course_tags

    attr_accessor :registration_tags

    attr_accessor :additionalvalues

    attr_accessor :launch_auth

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'expiry' => :'expiry',
        :'redirect_on_exit_url' => :'redirectOnExitUrl',
        :'tracking' => :'tracking',
        :'start_sco' => :'startSco',
        :'culture' => :'culture',
        :'css_url' => :'cssUrl',
        :'learner_tags' => :'learnerTags',
        :'course_tags' => :'courseTags',
        :'registration_tags' => :'registrationTags',
        :'additionalvalues' => :'additionalvalues',
        :'launch_auth' => :'launchAuth'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'expiry' => :'Integer',
        :'redirect_on_exit_url' => :'String',
        :'tracking' => :'BOOLEAN',
        :'start_sco' => :'String',
        :'culture' => :'String',
        :'css_url' => :'String',
        :'learner_tags' => :'Array<String>',
        :'course_tags' => :'Array<String>',
        :'registration_tags' => :'Array<String>',
        :'additionalvalues' => :'Array<ItemValuePairSchema>',
        :'launch_auth' => :'LaunchAuthSchema'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'expiry')
        self.expiry = attributes[:'expiry']
      else
        self.expiry = 120
      end

      if attributes.has_key?(:'redirectOnExitUrl')
        self.redirect_on_exit_url = attributes[:'redirectOnExitUrl']
      end

      if attributes.has_key?(:'tracking')
        self.tracking = attributes[:'tracking']
      else
        self.tracking = true
      end

      if attributes.has_key?(:'startSco')
        self.start_sco = attributes[:'startSco']
      end

      if attributes.has_key?(:'culture')
        self.culture = attributes[:'culture']
      end

      if attributes.has_key?(:'cssUrl')
        self.css_url = attributes[:'cssUrl']
      end

      if attributes.has_key?(:'learnerTags')
        if (value = attributes[:'learnerTags']).is_a?(Array)
          self.learner_tags = value
        end
      end

      if attributes.has_key?(:'courseTags')
        if (value = attributes[:'courseTags']).is_a?(Array)
          self.course_tags = value
        end
      end

      if attributes.has_key?(:'registrationTags')
        if (value = attributes[:'registrationTags']).is_a?(Array)
          self.registration_tags = value
        end
      end

      if attributes.has_key?(:'additionalvalues')
        if (value = attributes[:'additionalvalues']).is_a?(Array)
          self.additionalvalues = value
        end
      end

      if attributes.has_key?(:'launchAuth')
        self.launch_auth = attributes[:'launchAuth']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @redirect_on_exit_url.nil?
        invalid_properties.push('invalid value for "redirect_on_exit_url", redirect_on_exit_url cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @redirect_on_exit_url.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          expiry == o.expiry &&
          redirect_on_exit_url == o.redirect_on_exit_url &&
          tracking == o.tracking &&
          start_sco == o.start_sco &&
          culture == o.culture &&
          css_url == o.css_url &&
          learner_tags == o.learner_tags &&
          course_tags == o.course_tags &&
          registration_tags == o.registration_tags &&
          additionalvalues == o.additionalvalues &&
          launch_auth == o.launch_auth
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [expiry, redirect_on_exit_url, tracking, start_sco, culture, css_url, learner_tags, course_tags, registration_tags, additionalvalues, launch_auth].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = RusticiSoftwareCloudV2.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
